# swagger-java-client

E2E.pt API
- API version: 2.24.3
  - Build date: 2023-06-15T13:07:59.353Z

REST API para integração empresarial com os ERP <a href=\"http://www.primaverabss.com/\" target=\"_blank\">PRIMAVERA</a>, <a href=\"http://www.sage.pt/\" target=\"_blank\">SAGE</a>, <a href=\"https://www.phcsoftware.com/\" target=\"_blank\">PHC</a> e <a href=\"https://www.artsoft.pt/\" target=\"_blank\">ARTSOFT</a>.<br/><br/>Exemplos: <a href=\"https://e2e.pt/examples\" target=\"_blank\">https://e2e.pt/examples</a><br/><br/>Documentação: <a href=\"https://e2e.pt/documentation\" target=\"_blank\">https://e2e.pt/documentation</a><br/><br/>Mais informações, preços e demonstrações em: <a href=\"https://e2e.pt\" target=\"_blank\">https://e2e.pt</a>


*Automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen)*


## Requirements

Building the API client library requires:
1. Java 1.7+
2. Maven/Gradle

## Installation

To install the API client library to your local Maven repository, simply execute:

```shell
mvn clean install
```

To deploy it to a remote Maven repository instead, configure the settings of the repository and execute:

```shell
mvn clean deploy
```

Refer to the [OSSRH Guide](http://central.sonatype.org/pages/ossrh-guide.html) for more information.

### Maven users

Add this dependency to your project's POM:

```xml
<dependency>
  <groupId>io.swagger</groupId>
  <artifactId>swagger-java-client</artifactId>
  <version>1.0.0</version>
  <scope>compile</scope>
</dependency>
```

### Gradle users

Add this dependency to your project's build file:

```groovy
compile "io.swagger:swagger-java-client:1.0.0"
```

### Others

At first generate the JAR by executing:

```shell
mvn clean package
```

Then manually install the following JARs:

* `target/swagger-java-client-1.0.0.jar`
* `target/lib/*.jar`

## Getting Started

Please follow the [installation](#installation) instruction and execute the following Java code:

```java

import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.AccountApi;

import java.io.File;
import java.util.*;

public class AccountApiExample {

    public static void main(String[] args) {
        
        AccountApi apiInstance = new AccountApi();
        Account body = new Account(); // Account | 
        try {
            Account result = apiInstance.accountCreate(body);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling AccountApi#accountCreate");
            e.printStackTrace();
        }
    }
}

```

## Documentation for API Endpoints

All URIs are relative to *https://e2e.pt/ws*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AccountApi* | [**accountCreate**](docs/AccountApi.md#accountCreate) | **POST** /account | Create record
*AccountApi* | [**accountDelete**](docs/AccountApi.md#accountDelete) | **DELETE** /account/{id} | Delete record
*AccountApi* | [**accountId**](docs/AccountApi.md#accountId) | **GET** /account/id/{id} | Get record
*AccountApi* | [**accountList**](docs/AccountApi.md#accountList) | **GET** /account | List records
*AccountApi* | [**accountUpdate**](docs/AccountApi.md#accountUpdate) | **PUT** /account/{id} | Update record
*AccountApi* | [**addressCreate**](docs/AccountApi.md#addressCreate) | **POST** /account/{accountId}/address | Create record
*AccountApi* | [**addressDelete**](docs/AccountApi.md#addressDelete) | **DELETE** /account/{accountId}/address/{id} | Delete record
*AccountApi* | [**addressId**](docs/AccountApi.md#addressId) | **GET** /account/{accountId}/address/id/{id} | Get record
*AccountApi* | [**addressList**](docs/AccountApi.md#addressList) | **GET** /account/{accountId}/address | List records
*AccountApi* | [**addressUpdate**](docs/AccountApi.md#addressUpdate) | **PUT** /account/{accountId}/address/{id} | Update record
*AccountApi* | [**contactCreate**](docs/AccountApi.md#contactCreate) | **POST** /account/{accountId}/contact | Create record
*AccountApi* | [**contactDelete**](docs/AccountApi.md#contactDelete) | **DELETE** /account/{accountId}/contact/{id} | Delete record
*AccountApi* | [**contactId**](docs/AccountApi.md#contactId) | **GET** /account/{accountId}/contact/id/{id} | Get record
*AccountApi* | [**contactList**](docs/AccountApi.md#contactList) | **GET** /account/{accountId}/contact | List records
*AccountApi* | [**contactTypeList**](docs/AccountApi.md#contactTypeList) | **GET** /account/contact/type | List records
*AccountApi* | [**contactUpdate**](docs/AccountApi.md#contactUpdate) | **PUT** /account/{accountId}/contact/{id} | Update record
*AccountApi* | [**currentAccountList**](docs/AccountApi.md#currentAccountList) | **GET** /account/id/{id}/currentAccount | List customer or supplier current account
*DocumentApi* | [**documentCreate**](docs/DocumentApi.md#documentCreate) | **POST** /document | Create record
*DocumentApi* | [**documentDiscount**](docs/DocumentApi.md#documentDiscount) | **POST** /document/discount | Get document discount
*DocumentApi* | [**documentEmail**](docs/DocumentApi.md#documentEmail) | **PATCH** /document/email | Send document by mail
*DocumentApi* | [**documentId**](docs/DocumentApi.md#documentId) | **GET** /document/id/{id} | Get record
*DocumentApi* | [**documentList**](docs/DocumentApi.md#documentList) | **GET** /document | List records
*DocumentApi* | [**documenttypeList**](docs/DocumentApi.md#documenttypeList) | **GET** /document/type | List document types and series
*HrApi* | [**employeeAllFiles**](docs/HrApi.md#employeeAllFiles) | **GET** /hr/employee/files | Get files
*HrApi* | [**employeeCreate**](docs/HrApi.md#employeeCreate) | **POST** /hr/employee | Create record
*HrApi* | [**employeeDelete**](docs/HrApi.md#employeeDelete) | **DELETE** /hr/employee/{id} | Delete record
*HrApi* | [**employeeFileDownloadBase64**](docs/HrApi.md#employeeFileDownloadBase64) | **GET** /hr/employee/id/{id}/file/{fileId}/base64 | Get record file
*HrApi* | [**employeeFileDownloadBin**](docs/HrApi.md#employeeFileDownloadBin) | **GET** /hr/employee/id/{id}/file/{fileId}/bin | Get record file
*HrApi* | [**employeeFiles**](docs/HrApi.md#employeeFiles) | **GET** /hr/employee/id/{id}/file | Get record files
*HrApi* | [**employeeId**](docs/HrApi.md#employeeId) | **GET** /hr/employee/id/{id} | Get record
*HrApi* | [**employeeList**](docs/HrApi.md#employeeList) | **GET** /hr/employee | List records
*HrApi* | [**employeeUpdate**](docs/HrApi.md#employeeUpdate) | **PUT** /hr/employee/{id} | Update record
*HrApi* | [**monthlyPayrollSupplementCreate**](docs/HrApi.md#monthlyPayrollSupplementCreate) | **POST** /hr/monthly_payroll_supplement | Create record
*HrApi* | [**monthlyPayrollSupplementCreatePack**](docs/HrApi.md#monthlyPayrollSupplementCreatePack) | **POST** /hr/monthly_payroll_supplement/pack/{packid} | Create record
*HrApi* | [**monthlyPayrollSupplementDelete**](docs/HrApi.md#monthlyPayrollSupplementDelete) | **DELETE** /hr/monthly_payroll_supplement/id/{id} | Delete record
*HrApi* | [**monthlyPayrollSupplementDeleteExternalId**](docs/HrApi.md#monthlyPayrollSupplementDeleteExternalId) | **DELETE** /hr/monthly_payroll_supplement/external/{source}/{id} | Delete record
*HrApi* | [**monthlyPayrollSupplementDeleteExternalIdPack**](docs/HrApi.md#monthlyPayrollSupplementDeleteExternalIdPack) | **DELETE** /hr/monthly_payroll_supplement/external/{source}/{id}/pack/{packid} | Delete record
*HrApi* | [**monthlyPayrollSupplementDeletePack**](docs/HrApi.md#monthlyPayrollSupplementDeletePack) | **DELETE** /hr/monthly_payroll_supplement/id/{id}/pack/{packid} | Delete record
*HrApi* | [**monthlyPayrollSupplementExternalId**](docs/HrApi.md#monthlyPayrollSupplementExternalId) | **GET** /hr/monthly_payroll_supplement/external/{source}/{id} | Get record
*HrApi* | [**monthlyPayrollSupplementId**](docs/HrApi.md#monthlyPayrollSupplementId) | **GET** /hr/monthly_payroll_supplement/id/{id} | Get record
*HrApi* | [**monthlyPayrollSupplementList**](docs/HrApi.md#monthlyPayrollSupplementList) | **GET** /hr/monthly_payroll_supplement | List records
*HrApi* | [**monthlyPayrollSupplementUpdate**](docs/HrApi.md#monthlyPayrollSupplementUpdate) | **PUT** /hr/monthly_payroll_supplement/{id} | Update record
*HrApi* | [**monthlyPayrollSupplementUpdatePack**](docs/HrApi.md#monthlyPayrollSupplementUpdatePack) | **PUT** /hr/monthly_payroll_supplement/{id}/pack/{packid} | Update record
*HrApi* | [**payrollSupplementCreate**](docs/HrApi.md#payrollSupplementCreate) | **POST** /hr/payroll_supplement | Create record
*HrApi* | [**payrollSupplementCreatePack**](docs/HrApi.md#payrollSupplementCreatePack) | **POST** /hr/payroll_supplement/pack/{packid} | Create record
*HrApi* | [**payrollSupplementDelete**](docs/HrApi.md#payrollSupplementDelete) | **DELETE** /hr/payroll_supplement/id/{id} | Delete record
*HrApi* | [**payrollSupplementDeleteExternalId**](docs/HrApi.md#payrollSupplementDeleteExternalId) | **DELETE** /hr/payroll_supplement/external/{source}/{id} | Delete record
*HrApi* | [**payrollSupplementDeleteExternalIdPack**](docs/HrApi.md#payrollSupplementDeleteExternalIdPack) | **DELETE** /hr/payroll_supplement/external/{source}/{id}/pack/{packid} | Delete record
*HrApi* | [**payrollSupplementDeletePack**](docs/HrApi.md#payrollSupplementDeletePack) | **DELETE** /hr/payroll_supplement/id/{id}/pack/{packid} | Delete record
*HrApi* | [**payrollSupplementExternalId**](docs/HrApi.md#payrollSupplementExternalId) | **GET** /hr/payroll_supplement/external/{source}/{id} | Get record
*HrApi* | [**payrollSupplementId**](docs/HrApi.md#payrollSupplementId) | **GET** /hr/payroll_supplement/id/{id} | Get record
*HrApi* | [**payrollSupplementList**](docs/HrApi.md#payrollSupplementList) | **GET** /hr/payroll_supplement | List records
*HrApi* | [**payrollSupplementTypeList**](docs/HrApi.md#payrollSupplementTypeList) | **GET** /hr/payroll_supplement/payroll_supplement_type | List records
*HrApi* | [**payrollSupplementUpdate**](docs/HrApi.md#payrollSupplementUpdate) | **PUT** /hr/payroll_supplement/{id} | Update record
*HrApi* | [**payrollSupplementUpdatePack**](docs/HrApi.md#payrollSupplementUpdatePack) | **PUT** /hr/payroll_supplement/{id}/pack/{packid} | Update record
*HrApi* | [**timeAttendanceId**](docs/HrApi.md#timeAttendanceId) | **GET** /hr/time_attendance/id/{id} | Get record
*HrApi* | [**timeAttendanceList**](docs/HrApi.md#timeAttendanceList) | **GET** /hr/time_attendance | List records
*HrApi* | [**timeExtraCreate**](docs/HrApi.md#timeExtraCreate) | **POST** /hr/time_extra | Create record
*HrApi* | [**timeExtraCreatePack**](docs/HrApi.md#timeExtraCreatePack) | **POST** /hr/time_extra/pack/{packid} | Create record
*HrApi* | [**timeExtraDelete**](docs/HrApi.md#timeExtraDelete) | **DELETE** /hr/time_extra/id/{id} | Delete record
*HrApi* | [**timeExtraDeleteExternalId**](docs/HrApi.md#timeExtraDeleteExternalId) | **DELETE** /hr/time_extra/external/{source}/{id} | Delete record
*HrApi* | [**timeExtraDeleteExternalIdPack**](docs/HrApi.md#timeExtraDeleteExternalIdPack) | **DELETE** /hr/time_extra/external/{source}/{id}/pack/{packid} | Delete record
*HrApi* | [**timeExtraDeletePack**](docs/HrApi.md#timeExtraDeletePack) | **DELETE** /hr/time_extra/id/{id}/pack/{packid} | Delete record
*HrApi* | [**timeExtraExternalId**](docs/HrApi.md#timeExtraExternalId) | **GET** /hr/time_extra/external/{source}/{id} | Get record
*HrApi* | [**timeExtraId**](docs/HrApi.md#timeExtraId) | **GET** /hr/time_extra/id/{id} | Get record
*HrApi* | [**timeExtraList**](docs/HrApi.md#timeExtraList) | **GET** /hr/time_extra | List records
*HrApi* | [**timeExtraTypeList**](docs/HrApi.md#timeExtraTypeList) | **GET** /hr/time_extra/time_extra_type | List records
*HrApi* | [**timeExtraUpdate**](docs/HrApi.md#timeExtraUpdate) | **PUT** /hr/time_extra/{id} | Update record
*HrApi* | [**timeExtraUpdatePack**](docs/HrApi.md#timeExtraUpdatePack) | **PUT** /hr/time_extra/{id}/pack/{packid} | Update record
*HrApi* | [**timeOffLeaveCreate**](docs/HrApi.md#timeOffLeaveCreate) | **POST** /hr/time_off_leave | Create record
*HrApi* | [**timeOffLeaveDelete**](docs/HrApi.md#timeOffLeaveDelete) | **DELETE** /hr/time_off_leave/id/{id} | Delete record
*HrApi* | [**timeOffLeaveDeleteExternalId**](docs/HrApi.md#timeOffLeaveDeleteExternalId) | **DELETE** /hr/time_off_leave/external/{source}/{id} | Delete record
*HrApi* | [**timeOffLeaveExternalId**](docs/HrApi.md#timeOffLeaveExternalId) | **GET** /hr/time_off_leave/external/{source}/{id} | Get record
*HrApi* | [**timeOffLeaveId**](docs/HrApi.md#timeOffLeaveId) | **GET** /hr/time_off_leave/id/{id} | Get record
*HrApi* | [**timeOffLeaveList**](docs/HrApi.md#timeOffLeaveList) | **GET** /hr/time_off_leave | List records
*HrApi* | [**timeOffLeaveUpdate**](docs/HrApi.md#timeOffLeaveUpdate) | **PUT** /hr/time_off_leave/{id} | Update record
*HrApi* | [**timeOffLeavetypeList**](docs/HrApi.md#timeOffLeavetypeList) | **GET** /hr/time_off_leave/time_off_leave_type | List records
*ProductApi* | [**priceList**](docs/ProductApi.md#priceList) | **GET** /product/price | List product prices
*ProductApi* | [**priceTypeList**](docs/ProductApi.md#priceTypeList) | **GET** /product/price/type | List product prices type
*ProductApi* | [**productCategoryList**](docs/ProductApi.md#productCategoryList) | **GET** /product/category | List product categories
*ProductApi* | [**productCreate**](docs/ProductApi.md#productCreate) | **POST** /product | Create record
*ProductApi* | [**productDelete**](docs/ProductApi.md#productDelete) | **DELETE** /product/{id} | Delete record
*ProductApi* | [**productId**](docs/ProductApi.md#productId) | **GET** /product/id/{id} | Get record
*ProductApi* | [**productList**](docs/ProductApi.md#productList) | **GET** /product | List records
*ProductApi* | [**productUpdate**](docs/ProductApi.md#productUpdate) | **PUT** /product/{id} | Update record
*ProductApi* | [**stockList**](docs/ProductApi.md#stockList) | **GET** /product/stock | List records
*ToolsApi* | [**querySql**](docs/ToolsApi.md#querySql) | **POST** /tools/query | Execute SQL Command


## Documentation for Models

 - [Account](docs/Account.md)
 - [AccountListContainer](docs/AccountListContainer.md)
 - [Address](docs/Address.md)
 - [AddressListContainer](docs/AddressListContainer.md)
 - [Column](docs/Column.md)
 - [Contact](docs/Contact.md)
 - [ContactListContainer](docs/ContactListContainer.md)
 - [ContactType](docs/ContactType.md)
 - [ContactTypeListContainer](docs/ContactTypeListContainer.md)
 - [Country](docs/Country.md)
 - [CurrentAccount](docs/CurrentAccount.md)
 - [CurrentAccountListContainer](docs/CurrentAccountListContainer.md)
 - [Document](docs/Document.md)
 - [DocumentLine](docs/DocumentLine.md)
 - [DocumentListContainer](docs/DocumentListContainer.md)
 - [DocumentSerie](docs/DocumentSerie.md)
 - [DocumentType](docs/DocumentType.md)
 - [DocumentTypeListContainer](docs/DocumentTypeListContainer.md)
 - [Employee](docs/Employee.md)
 - [EmployeeListContainer](docs/EmployeeListContainer.md)
 - [File](docs/File.md)
 - [FileListContainer](docs/FileListContainer.md)
 - [I18nText](docs/I18nText.md)
 - [Lot](docs/Lot.md)
 - [Pair](docs/Pair.md)
 - [PaymentMethod](docs/PaymentMethod.md)
 - [PaymentTerms](docs/PaymentTerms.md)
 - [PayrollSupplement](docs/PayrollSupplement.md)
 - [PayrollSupplementListContainer](docs/PayrollSupplementListContainer.md)
 - [PayrollSupplementType](docs/PayrollSupplementType.md)
 - [PayrollSupplementTypeListContainer](docs/PayrollSupplementTypeListContainer.md)
 - [Price](docs/Price.md)
 - [PriceListContainer](docs/PriceListContainer.md)
 - [PriceType](docs/PriceType.md)
 - [PriceTypeListContainer](docs/PriceTypeListContainer.md)
 - [Product](docs/Product.md)
 - [ProductAttribute](docs/ProductAttribute.md)
 - [ProductCategory](docs/ProductCategory.md)
 - [ProductCategoryListContainer](docs/ProductCategoryListContainer.md)
 - [ProductFeature](docs/ProductFeature.md)
 - [ProductFeatureValue](docs/ProductFeatureValue.md)
 - [ProductListContainer](docs/ProductListContainer.md)
 - [QueryResultDTO](docs/QueryResultDTO.md)
 - [Record](docs/Record.md)
 - [Salesman](docs/Salesman.md)
 - [Stock](docs/Stock.md)
 - [StockListContainer](docs/StockListContainer.md)
 - [Tax](docs/Tax.md)
 - [TaxRule](docs/TaxRule.md)
 - [TaxZone](docs/TaxZone.md)
 - [TimeAttendance](docs/TimeAttendance.md)
 - [TimeAttendanceListContainer](docs/TimeAttendanceListContainer.md)
 - [TimeExtra](docs/TimeExtra.md)
 - [TimeExtraListContainer](docs/TimeExtraListContainer.md)
 - [TimeExtraType](docs/TimeExtraType.md)
 - [TimeExtraTypeListContainer](docs/TimeExtraTypeListContainer.md)
 - [TimeOffLeave](docs/TimeOffLeave.md)
 - [TimeOffLeaveListContainer](docs/TimeOffLeaveListContainer.md)
 - [TimeOffLeaveType](docs/TimeOffLeaveType.md)
 - [TimeOffLeaveTypeListContainer](docs/TimeOffLeaveTypeListContainer.md)
 - [Unit](docs/Unit.md)
 - [Warehouse](docs/Warehouse.md)


## Documentation for Authorization

Authentication schemes defined for the API:
### api_key

- **Type**: API key
- **API key parameter name**: api_key
- **Location**: HTTP header

### company_key

- **Type**: API key
- **API key parameter name**: company_key
- **Location**: HTTP header


## Recommendation

It's recommended to create an instance of `ApiClient` per thread in a multithreaded environment to avoid any potential issues.

## Author



