# ProductApi

All URIs are relative to *https://e2e.pt/ws*

Method | HTTP request | Description
------------- | ------------- | -------------
[**priceList**](ProductApi.md#priceList) | **GET** /product/price | List product prices
[**priceTypeList**](ProductApi.md#priceTypeList) | **GET** /product/price/type | List product prices type
[**productCategoryList**](ProductApi.md#productCategoryList) | **GET** /product/category | List product categories
[**productCreate**](ProductApi.md#productCreate) | **POST** /product | Create record
[**productDelete**](ProductApi.md#productDelete) | **DELETE** /product/{id} | Delete record
[**productId**](ProductApi.md#productId) | **GET** /product/id/{id} | Get record
[**productList**](ProductApi.md#productList) | **GET** /product | List records
[**productUpdate**](ProductApi.md#productUpdate) | **PUT** /product/{id} | Update record
[**stockList**](ProductApi.md#stockList) | **GET** /product/stock | List records


<a name="priceList"></a>
# **priceList**
> PriceListContainer priceList(offset, limit, priceType, currency, unit, productIds)

List product prices



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ProductApi;


ProductApi apiInstance = new ProductApi();
Integer offset = 0; // Integer | 
Integer limit = 100; // Integer | 
String priceType = "priceType_example"; // String | 
String currency = "currency_example"; // String | 
String unit = "unit_example"; // String | 
List<String> productIds = Arrays.asList("productIds_example"); // List<String> | 
try {
    PriceListContainer result = apiInstance.priceList(offset, limit, priceType, currency, unit, productIds);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ProductApi#priceList");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **Integer**|  | [optional] [default to 0]
 **limit** | **Integer**|  | [optional] [default to 100]
 **priceType** | **String**|  | [optional]
 **currency** | **String**|  | [optional]
 **unit** | **String**|  | [optional]
 **productIds** | [**List&lt;String&gt;**](String.md)|  | [optional]

### Return type

[**PriceListContainer**](PriceListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="priceTypeList"></a>
# **priceTypeList**
> PriceTypeListContainer priceTypeList()

List product prices type



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ProductApi;


ProductApi apiInstance = new ProductApi();
try {
    PriceTypeListContainer result = apiInstance.priceTypeList();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ProductApi#priceTypeList");
    e.printStackTrace();
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**PriceTypeListContainer**](PriceTypeListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="productCategoryList"></a>
# **productCategoryList**
> ProductCategoryListContainer productCategoryList()

List product categories



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ProductApi;


ProductApi apiInstance = new ProductApi();
try {
    ProductCategoryListContainer result = apiInstance.productCategoryList();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ProductApi#productCategoryList");
    e.printStackTrace();
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**ProductCategoryListContainer**](ProductCategoryListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="productCreate"></a>
# **productCreate**
> Product productCreate(body)

Create record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ProductApi;


ProductApi apiInstance = new ProductApi();
Product body = new Product(); // Product | 
try {
    Product result = apiInstance.productCreate(body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ProductApi#productCreate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Product**](Product.md)|  |

### Return type

[**Product**](Product.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="productDelete"></a>
# **productDelete**
> productDelete(id)

Delete record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ProductApi;


ProductApi apiInstance = new ProductApi();
String id = "id_example"; // String | 
try {
    apiInstance.productDelete(id);
} catch (ApiException e) {
    System.err.println("Exception when calling ProductApi#productDelete");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="productId"></a>
# **productId**
> Product productId(id)

Get record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ProductApi;


ProductApi apiInstance = new ProductApi();
String id = "id_example"; // String | 
try {
    Product result = apiInstance.productId(id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ProductApi#productId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |

### Return type

[**Product**](Product.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="productList"></a>
# **productList**
> ProductListContainer productList(offset, limit, name, published, updateDate, productCategory, deleted, ids, extraFieldsExpression, extraFields)

List records



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ProductApi;


ProductApi apiInstance = new ProductApi();
Integer offset = 0; // Integer | 
Integer limit = 100; // Integer | 
String name = "name_example"; // String | 
Boolean published = true; // Boolean | 
OffsetDateTime updateDate = OffsetDateTime.now(); // OffsetDateTime | ISO 8601
String productCategory = "productCategory_example"; // String | 
Boolean deleted = true; // Boolean | 
List<String> ids = Arrays.asList("ids_example"); // List<String> | 
String extraFieldsExpression = "extraFieldsExpression_example"; // String | 
List<String> extraFields = Arrays.asList("extraFields_example"); // List<String> | 
try {
    ProductListContainer result = apiInstance.productList(offset, limit, name, published, updateDate, productCategory, deleted, ids, extraFieldsExpression, extraFields);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ProductApi#productList");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **Integer**|  | [optional] [default to 0]
 **limit** | **Integer**|  | [optional] [default to 100]
 **name** | **String**|  | [optional]
 **published** | **Boolean**|  | [optional]
 **updateDate** | **OffsetDateTime**| ISO 8601 | [optional]
 **productCategory** | **String**|  | [optional]
 **deleted** | **Boolean**|  | [optional]
 **ids** | [**List&lt;String&gt;**](String.md)|  | [optional]
 **extraFieldsExpression** | **String**|  | [optional]
 **extraFields** | [**List&lt;String&gt;**](String.md)|  | [optional]

### Return type

[**ProductListContainer**](ProductListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="productUpdate"></a>
# **productUpdate**
> Product productUpdate(id, body)

Update record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ProductApi;


ProductApi apiInstance = new ProductApi();
String id = "id_example"; // String | 
Product body = new Product(); // Product | 
try {
    Product result = apiInstance.productUpdate(id, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ProductApi#productUpdate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |
 **body** | [**Product**](Product.md)|  |

### Return type

[**Product**](Product.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="stockList"></a>
# **stockList**
> StockListContainer stockList(offset, limit, unit, productIds, warehouseIds)

List records



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ProductApi;


ProductApi apiInstance = new ProductApi();
Integer offset = 0; // Integer | 
Integer limit = 100; // Integer | 
String unit = "unit_example"; // String | 
List<String> productIds = Arrays.asList("productIds_example"); // List<String> | 
List<String> warehouseIds = Arrays.asList("warehouseIds_example"); // List<String> | 
try {
    StockListContainer result = apiInstance.stockList(offset, limit, unit, productIds, warehouseIds);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ProductApi#stockList");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **Integer**|  | [optional] [default to 0]
 **limit** | **Integer**|  | [optional] [default to 100]
 **unit** | **String**|  | [optional]
 **productIds** | [**List&lt;String&gt;**](String.md)|  | [optional]
 **warehouseIds** | [**List&lt;String&gt;**](String.md)|  | [optional]

### Return type

[**StockListContainer**](StockListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

