/*
 * E2E.pt API
 * REST API para integração empresarial com os ERP <a href=\"http://www.primaverabss.com/\" target=\"_blank\">PRIMAVERA</a>, <a href=\"http://www.sage.pt/\" target=\"_blank\">SAGE</a>, <a href=\"https://www.phcsoftware.com/\" target=\"_blank\">PHC</a> e <a href=\"https://www.artsoft.pt/\" target=\"_blank\">ARTSOFT</a>.<br/><br/>Exemplos: <a href=\"https://e2e.pt/examples\" target=\"_blank\">https://e2e.pt/examples</a><br/><br/>Documentação: <a href=\"https://e2e.pt/documentation\" target=\"_blank\">https://e2e.pt/documentation</a><br/><br/>Mais informações, preços e demonstrações em: <a href=\"https://e2e.pt\" target=\"_blank\">https://e2e.pt</a>
 *
 * OpenAPI spec version: 2.24.3
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.Document;
import io.swagger.client.model.DocumentListContainer;
import io.swagger.client.model.DocumentTypeListContainer;
import org.threeten.bp.OffsetDateTime;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class DocumentApi {
    private ApiClient apiClient;

    public DocumentApi() {
        this(Configuration.getDefaultApiClient());
    }

    public DocumentApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for documentCreate
     * @param body  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call documentCreateCall(Document body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/document";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call documentCreateValidateBeforeCall(Document body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling documentCreate(Async)");
        }
        

        com.squareup.okhttp.Call call = documentCreateCall(body, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Create record
     * 
     * @param body  (required)
     * @return Document
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Document documentCreate(Document body) throws ApiException {
        ApiResponse<Document> resp = documentCreateWithHttpInfo(body);
        return resp.getData();
    }

    /**
     * Create record
     * 
     * @param body  (required)
     * @return ApiResponse&lt;Document&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Document> documentCreateWithHttpInfo(Document body) throws ApiException {
        com.squareup.okhttp.Call call = documentCreateValidateBeforeCall(body, null, null);
        Type localVarReturnType = new TypeToken<Document>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create record (asynchronously)
     * 
     * @param body  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call documentCreateAsync(Document body, final ApiCallback<Document> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = documentCreateValidateBeforeCall(body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Document>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for documentDiscount
     * @param body  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call documentDiscountCall(Document body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/document/discount";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call documentDiscountValidateBeforeCall(Document body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling documentDiscount(Async)");
        }
        

        com.squareup.okhttp.Call call = documentDiscountCall(body, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get document discount
     * 
     * @param body  (required)
     * @return Document
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Document documentDiscount(Document body) throws ApiException {
        ApiResponse<Document> resp = documentDiscountWithHttpInfo(body);
        return resp.getData();
    }

    /**
     * Get document discount
     * 
     * @param body  (required)
     * @return ApiResponse&lt;Document&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Document> documentDiscountWithHttpInfo(Document body) throws ApiException {
        com.squareup.okhttp.Call call = documentDiscountValidateBeforeCall(body, null, null);
        Type localVarReturnType = new TypeToken<Document>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get document discount (asynchronously)
     * 
     * @param body  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call documentDiscountAsync(Document body, final ApiCallback<Document> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = documentDiscountValidateBeforeCall(body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Document>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for documentEmail
     * @param id  (required)
     * @param toEmail  (optional)
     * @param fromEmail  (optional)
     * @param fromName  (optional)
     * @param subject  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call documentEmailCall(String id, String toEmail, String fromEmail, String fromName, String subject, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/document/email";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (id != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("id", id));
        if (toEmail != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("toEmail", toEmail));
        if (fromEmail != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fromEmail", fromEmail));
        if (fromName != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fromName", fromName));
        if (subject != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("subject", subject));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PATCH", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call documentEmailValidateBeforeCall(String id, String toEmail, String fromEmail, String fromName, String subject, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling documentEmail(Async)");
        }
        

        com.squareup.okhttp.Call call = documentEmailCall(id, toEmail, fromEmail, fromName, subject, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Send document by mail
     * 
     * @param id  (required)
     * @param toEmail  (optional)
     * @param fromEmail  (optional)
     * @param fromName  (optional)
     * @param subject  (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void documentEmail(String id, String toEmail, String fromEmail, String fromName, String subject) throws ApiException {
        documentEmailWithHttpInfo(id, toEmail, fromEmail, fromName, subject);
    }

    /**
     * Send document by mail
     * 
     * @param id  (required)
     * @param toEmail  (optional)
     * @param fromEmail  (optional)
     * @param fromName  (optional)
     * @param subject  (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> documentEmailWithHttpInfo(String id, String toEmail, String fromEmail, String fromName, String subject) throws ApiException {
        com.squareup.okhttp.Call call = documentEmailValidateBeforeCall(id, toEmail, fromEmail, fromName, subject, null, null);
        return apiClient.execute(call);
    }

    /**
     * Send document by mail (asynchronously)
     * 
     * @param id  (required)
     * @param toEmail  (optional)
     * @param fromEmail  (optional)
     * @param fromName  (optional)
     * @param subject  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call documentEmailAsync(String id, String toEmail, String fromEmail, String fromName, String subject, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = documentEmailValidateBeforeCall(id, toEmail, fromEmail, fromName, subject, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for documentId
     * @param id  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call documentIdCall(String id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/document/id/{id}"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call documentIdValidateBeforeCall(String id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling documentId(Async)");
        }
        

        com.squareup.okhttp.Call call = documentIdCall(id, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get record
     * 
     * @param id  (required)
     * @return Document
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Document documentId(String id) throws ApiException {
        ApiResponse<Document> resp = documentIdWithHttpInfo(id);
        return resp.getData();
    }

    /**
     * Get record
     * 
     * @param id  (required)
     * @return ApiResponse&lt;Document&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Document> documentIdWithHttpInfo(String id) throws ApiException {
        com.squareup.okhttp.Call call = documentIdValidateBeforeCall(id, null, null);
        Type localVarReturnType = new TypeToken<Document>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get record (asynchronously)
     * 
     * @param id  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call documentIdAsync(String id, final ApiCallback<Document> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = documentIdValidateBeforeCall(id, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Document>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for documentList
     * @param offset  (optional, default to 0)
     * @param limit  (optional, default to 100)
     * @param number  (optional)
     * @param startDate ISO 8601 (optional)
     * @param endDate ISO 8601 (optional)
     * @param type1  (optional)
     * @param type2  (optional)
     * @param updateDate ISO 8601 (optional)
     * @param account  (optional)
     * @param product  (optional)
     * @param productCategory  (optional)
     * @param deleted  (optional)
     * @param name  (optional)
     * @param type  (optional)
     * @param serie  (optional)
     * @param salesman  (optional)
     * @param extraFieldsExpression  (optional)
     * @param extraFields  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call documentListCall(Integer offset, Integer limit, Integer number, OffsetDateTime startDate, OffsetDateTime endDate, String type1, String type2, OffsetDateTime updateDate, String account, String product, String productCategory, Boolean deleted, String name, List<String> type, List<String> serie, List<String> salesman, String extraFieldsExpression, List<String> extraFields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/document";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("offset", offset));
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("limit", limit));
        if (number != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("number", number));
        if (startDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("startDate", startDate));
        if (endDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("endDate", endDate));
        if (type1 != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("type1", type1));
        if (type2 != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("type2", type2));
        if (updateDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("updateDate", updateDate));
        if (account != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("account", account));
        if (product != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("product", product));
        if (productCategory != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("productCategory", productCategory));
        if (deleted != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("deleted", deleted));
        if (name != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("name", name));
        if (type != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("multi", "type", type));
        if (serie != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("multi", "serie", serie));
        if (salesman != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("multi", "salesman", salesman));
        if (extraFieldsExpression != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("extra_fields_expression", extraFieldsExpression));
        if (extraFields != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("multi", "extra_fields", extraFields));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call documentListValidateBeforeCall(Integer offset, Integer limit, Integer number, OffsetDateTime startDate, OffsetDateTime endDate, String type1, String type2, OffsetDateTime updateDate, String account, String product, String productCategory, Boolean deleted, String name, List<String> type, List<String> serie, List<String> salesman, String extraFieldsExpression, List<String> extraFields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = documentListCall(offset, limit, number, startDate, endDate, type1, type2, updateDate, account, product, productCategory, deleted, name, type, serie, salesman, extraFieldsExpression, extraFields, progressListener, progressRequestListener);
        return call;

    }

    /**
     * List records
     * 
     * @param offset  (optional, default to 0)
     * @param limit  (optional, default to 100)
     * @param number  (optional)
     * @param startDate ISO 8601 (optional)
     * @param endDate ISO 8601 (optional)
     * @param type1  (optional)
     * @param type2  (optional)
     * @param updateDate ISO 8601 (optional)
     * @param account  (optional)
     * @param product  (optional)
     * @param productCategory  (optional)
     * @param deleted  (optional)
     * @param name  (optional)
     * @param type  (optional)
     * @param serie  (optional)
     * @param salesman  (optional)
     * @param extraFieldsExpression  (optional)
     * @param extraFields  (optional)
     * @return DocumentListContainer
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public DocumentListContainer documentList(Integer offset, Integer limit, Integer number, OffsetDateTime startDate, OffsetDateTime endDate, String type1, String type2, OffsetDateTime updateDate, String account, String product, String productCategory, Boolean deleted, String name, List<String> type, List<String> serie, List<String> salesman, String extraFieldsExpression, List<String> extraFields) throws ApiException {
        ApiResponse<DocumentListContainer> resp = documentListWithHttpInfo(offset, limit, number, startDate, endDate, type1, type2, updateDate, account, product, productCategory, deleted, name, type, serie, salesman, extraFieldsExpression, extraFields);
        return resp.getData();
    }

    /**
     * List records
     * 
     * @param offset  (optional, default to 0)
     * @param limit  (optional, default to 100)
     * @param number  (optional)
     * @param startDate ISO 8601 (optional)
     * @param endDate ISO 8601 (optional)
     * @param type1  (optional)
     * @param type2  (optional)
     * @param updateDate ISO 8601 (optional)
     * @param account  (optional)
     * @param product  (optional)
     * @param productCategory  (optional)
     * @param deleted  (optional)
     * @param name  (optional)
     * @param type  (optional)
     * @param serie  (optional)
     * @param salesman  (optional)
     * @param extraFieldsExpression  (optional)
     * @param extraFields  (optional)
     * @return ApiResponse&lt;DocumentListContainer&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<DocumentListContainer> documentListWithHttpInfo(Integer offset, Integer limit, Integer number, OffsetDateTime startDate, OffsetDateTime endDate, String type1, String type2, OffsetDateTime updateDate, String account, String product, String productCategory, Boolean deleted, String name, List<String> type, List<String> serie, List<String> salesman, String extraFieldsExpression, List<String> extraFields) throws ApiException {
        com.squareup.okhttp.Call call = documentListValidateBeforeCall(offset, limit, number, startDate, endDate, type1, type2, updateDate, account, product, productCategory, deleted, name, type, serie, salesman, extraFieldsExpression, extraFields, null, null);
        Type localVarReturnType = new TypeToken<DocumentListContainer>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * List records (asynchronously)
     * 
     * @param offset  (optional, default to 0)
     * @param limit  (optional, default to 100)
     * @param number  (optional)
     * @param startDate ISO 8601 (optional)
     * @param endDate ISO 8601 (optional)
     * @param type1  (optional)
     * @param type2  (optional)
     * @param updateDate ISO 8601 (optional)
     * @param account  (optional)
     * @param product  (optional)
     * @param productCategory  (optional)
     * @param deleted  (optional)
     * @param name  (optional)
     * @param type  (optional)
     * @param serie  (optional)
     * @param salesman  (optional)
     * @param extraFieldsExpression  (optional)
     * @param extraFields  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call documentListAsync(Integer offset, Integer limit, Integer number, OffsetDateTime startDate, OffsetDateTime endDate, String type1, String type2, OffsetDateTime updateDate, String account, String product, String productCategory, Boolean deleted, String name, List<String> type, List<String> serie, List<String> salesman, String extraFieldsExpression, List<String> extraFields, final ApiCallback<DocumentListContainer> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = documentListValidateBeforeCall(offset, limit, number, startDate, endDate, type1, type2, updateDate, account, product, productCategory, deleted, name, type, serie, salesman, extraFieldsExpression, extraFields, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<DocumentListContainer>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for documenttypeList
     * @param type  (optional)
     * @param serie  (optional)
     * @param type1  (optional)
     * @param type2  (optional)
     * @param userType  (optional)
     * @param userId  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call documenttypeListCall(String type, String serie, String type1, String type2, String userType, String userId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/document/type";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (type != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("type", type));
        if (serie != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("serie", serie));
        if (type1 != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("type1", type1));
        if (type2 != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("type2", type2));
        if (userType != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("userType", userType));
        if (userId != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("userId", userId));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call documenttypeListValidateBeforeCall(String type, String serie, String type1, String type2, String userType, String userId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = documenttypeListCall(type, serie, type1, type2, userType, userId, progressListener, progressRequestListener);
        return call;

    }

    /**
     * List document types and series
     * 
     * @param type  (optional)
     * @param serie  (optional)
     * @param type1  (optional)
     * @param type2  (optional)
     * @param userType  (optional)
     * @param userId  (optional)
     * @return DocumentTypeListContainer
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public DocumentTypeListContainer documenttypeList(String type, String serie, String type1, String type2, String userType, String userId) throws ApiException {
        ApiResponse<DocumentTypeListContainer> resp = documenttypeListWithHttpInfo(type, serie, type1, type2, userType, userId);
        return resp.getData();
    }

    /**
     * List document types and series
     * 
     * @param type  (optional)
     * @param serie  (optional)
     * @param type1  (optional)
     * @param type2  (optional)
     * @param userType  (optional)
     * @param userId  (optional)
     * @return ApiResponse&lt;DocumentTypeListContainer&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<DocumentTypeListContainer> documenttypeListWithHttpInfo(String type, String serie, String type1, String type2, String userType, String userId) throws ApiException {
        com.squareup.okhttp.Call call = documenttypeListValidateBeforeCall(type, serie, type1, type2, userType, userId, null, null);
        Type localVarReturnType = new TypeToken<DocumentTypeListContainer>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * List document types and series (asynchronously)
     * 
     * @param type  (optional)
     * @param serie  (optional)
     * @param type1  (optional)
     * @param type2  (optional)
     * @param userType  (optional)
     * @param userId  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call documenttypeListAsync(String type, String serie, String type1, String type2, String userType, String userId, final ApiCallback<DocumentTypeListContainer> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = documenttypeListValidateBeforeCall(type, serie, type1, type2, userType, userId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<DocumentTypeListContainer>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
