/*
 * E2E.pt API
 * REST API para integração empresarial com os ERP <a href=\"http://www.primaverabss.com/\" target=\"_blank\">PRIMAVERA</a>, <a href=\"http://www.sage.pt/\" target=\"_blank\">SAGE</a>, <a href=\"https://www.phcsoftware.com/\" target=\"_blank\">PHC</a> e <a href=\"https://www.artsoft.pt/\" target=\"_blank\">ARTSOFT</a>.<br/><br/>Exemplos: <a href=\"https://e2e.pt/examples\" target=\"_blank\">https://e2e.pt/examples</a><br/><br/>Documentação: <a href=\"https://e2e.pt/documentation\" target=\"_blank\">https://e2e.pt/documentation</a><br/><br/>Mais informações, preços e demonstrações em: <a href=\"https://e2e.pt\" target=\"_blank\">https://e2e.pt</a>
 *
 * OpenAPI spec version: 2.24.3
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.Address;
import io.swagger.client.model.Pair;
import io.swagger.client.model.PaymentMethod;
import io.swagger.client.model.PaymentTerms;
import io.swagger.client.model.PriceType;
import io.swagger.client.model.Product;
import io.swagger.client.model.Salesman;
import io.swagger.client.model.TaxRule;
import io.swagger.client.model.TaxZone;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import org.threeten.bp.OffsetDateTime;

/**
 * Account
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2023-06-15T13:07:59.353Z")
public class Account {
  @SerializedName("id")
  private String id = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("utlIns")
  private String utlIns = null;

  @SerializedName("dtIns")
  private OffsetDateTime dtIns = null;

  @SerializedName("utlAlt")
  private String utlAlt = null;

  @SerializedName("dtAlt")
  private OffsetDateTime dtAlt = null;

  @SerializedName("deleted")
  private Boolean deleted = null;

  @SerializedName("extra")
  private List<Pair> extra = null;

  @SerializedName("externalId")
  private String externalId = null;

  @SerializedName("externalSource")
  private String externalSource = null;

  /**
   * Gets or Sets type
   */
  @JsonAdapter(TypeEnum.Adapter.class)
  public enum TypeEnum {
    CLIENT("CLIENT"),
    
    SUPPLIER("SUPPLIER");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static TypeEnum fromValue(String text) {
      for (TypeEnum b : TypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<TypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final TypeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public TypeEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return TypeEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("type")
  private TypeEnum type = null;

  @SerializedName("vatNumber")
  private String vatNumber = null;

  @SerializedName("email")
  private String email = null;

  @SerializedName("phone")
  private String phone = null;

  @SerializedName("paymentTerm")
  private PaymentTerms paymentTerm = null;

  @SerializedName("paymentMethod")
  private PaymentMethod paymentMethod = null;

  @SerializedName("taxZone")
  private TaxZone taxZone = null;

  @SerializedName("taxRule")
  private TaxRule taxRule = null;

  @SerializedName("address")
  private List<Address> address = null;

  @SerializedName("salesman")
  private List<Salesman> salesman = null;

  @SerializedName("balance")
  private BigDecimal balance = null;

  @SerializedName("currency")
  private String currency = null;

  @SerializedName("priceType")
  private PriceType priceType = null;

  @SerializedName("products")
  private List<Product> products = null;

  public Account id(String id) {
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @ApiModelProperty(value = "")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public Account name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Get name
   * @return name
  **/
  @ApiModelProperty(value = "")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Account utlIns(String utlIns) {
    this.utlIns = utlIns;
    return this;
  }

   /**
   * Get utlIns
   * @return utlIns
  **/
  @ApiModelProperty(value = "")
  public String getUtlIns() {
    return utlIns;
  }

  public void setUtlIns(String utlIns) {
    this.utlIns = utlIns;
  }

  public Account dtIns(OffsetDateTime dtIns) {
    this.dtIns = dtIns;
    return this;
  }

   /**
   * Get dtIns
   * @return dtIns
  **/
  @ApiModelProperty(value = "")
  public OffsetDateTime getDtIns() {
    return dtIns;
  }

  public void setDtIns(OffsetDateTime dtIns) {
    this.dtIns = dtIns;
  }

  public Account utlAlt(String utlAlt) {
    this.utlAlt = utlAlt;
    return this;
  }

   /**
   * Get utlAlt
   * @return utlAlt
  **/
  @ApiModelProperty(value = "")
  public String getUtlAlt() {
    return utlAlt;
  }

  public void setUtlAlt(String utlAlt) {
    this.utlAlt = utlAlt;
  }

  public Account dtAlt(OffsetDateTime dtAlt) {
    this.dtAlt = dtAlt;
    return this;
  }

   /**
   * Get dtAlt
   * @return dtAlt
  **/
  @ApiModelProperty(value = "")
  public OffsetDateTime getDtAlt() {
    return dtAlt;
  }

  public void setDtAlt(OffsetDateTime dtAlt) {
    this.dtAlt = dtAlt;
  }

  public Account deleted(Boolean deleted) {
    this.deleted = deleted;
    return this;
  }

   /**
   * Get deleted
   * @return deleted
  **/
  @ApiModelProperty(value = "")
  public Boolean isDeleted() {
    return deleted;
  }

  public void setDeleted(Boolean deleted) {
    this.deleted = deleted;
  }

  public Account extra(List<Pair> extra) {
    this.extra = extra;
    return this;
  }

  public Account addExtraItem(Pair extraItem) {
    if (this.extra == null) {
      this.extra = new ArrayList<Pair>();
    }
    this.extra.add(extraItem);
    return this;
  }

   /**
   * Get extra
   * @return extra
  **/
  @ApiModelProperty(value = "")
  public List<Pair> getExtra() {
    return extra;
  }

  public void setExtra(List<Pair> extra) {
    this.extra = extra;
  }

  public Account externalId(String externalId) {
    this.externalId = externalId;
    return this;
  }

   /**
   * Get externalId
   * @return externalId
  **/
  @ApiModelProperty(value = "")
  public String getExternalId() {
    return externalId;
  }

  public void setExternalId(String externalId) {
    this.externalId = externalId;
  }

  public Account externalSource(String externalSource) {
    this.externalSource = externalSource;
    return this;
  }

   /**
   * Get externalSource
   * @return externalSource
  **/
  @ApiModelProperty(value = "")
  public String getExternalSource() {
    return externalSource;
  }

  public void setExternalSource(String externalSource) {
    this.externalSource = externalSource;
  }

  public Account type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * Get type
   * @return type
  **/
  @ApiModelProperty(value = "")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

  public Account vatNumber(String vatNumber) {
    this.vatNumber = vatNumber;
    return this;
  }

   /**
   * Get vatNumber
   * @return vatNumber
  **/
  @ApiModelProperty(value = "")
  public String getVatNumber() {
    return vatNumber;
  }

  public void setVatNumber(String vatNumber) {
    this.vatNumber = vatNumber;
  }

  public Account email(String email) {
    this.email = email;
    return this;
  }

   /**
   * Get email
   * @return email
  **/
  @ApiModelProperty(value = "")
  public String getEmail() {
    return email;
  }

  public void setEmail(String email) {
    this.email = email;
  }

  public Account phone(String phone) {
    this.phone = phone;
    return this;
  }

   /**
   * Get phone
   * @return phone
  **/
  @ApiModelProperty(value = "")
  public String getPhone() {
    return phone;
  }

  public void setPhone(String phone) {
    this.phone = phone;
  }

  public Account paymentTerm(PaymentTerms paymentTerm) {
    this.paymentTerm = paymentTerm;
    return this;
  }

   /**
   * Get paymentTerm
   * @return paymentTerm
  **/
  @ApiModelProperty(value = "")
  public PaymentTerms getPaymentTerm() {
    return paymentTerm;
  }

  public void setPaymentTerm(PaymentTerms paymentTerm) {
    this.paymentTerm = paymentTerm;
  }

  public Account paymentMethod(PaymentMethod paymentMethod) {
    this.paymentMethod = paymentMethod;
    return this;
  }

   /**
   * Get paymentMethod
   * @return paymentMethod
  **/
  @ApiModelProperty(value = "")
  public PaymentMethod getPaymentMethod() {
    return paymentMethod;
  }

  public void setPaymentMethod(PaymentMethod paymentMethod) {
    this.paymentMethod = paymentMethod;
  }

  public Account taxZone(TaxZone taxZone) {
    this.taxZone = taxZone;
    return this;
  }

   /**
   * Get taxZone
   * @return taxZone
  **/
  @ApiModelProperty(value = "")
  public TaxZone getTaxZone() {
    return taxZone;
  }

  public void setTaxZone(TaxZone taxZone) {
    this.taxZone = taxZone;
  }

  public Account taxRule(TaxRule taxRule) {
    this.taxRule = taxRule;
    return this;
  }

   /**
   * Get taxRule
   * @return taxRule
  **/
  @ApiModelProperty(value = "")
  public TaxRule getTaxRule() {
    return taxRule;
  }

  public void setTaxRule(TaxRule taxRule) {
    this.taxRule = taxRule;
  }

  public Account address(List<Address> address) {
    this.address = address;
    return this;
  }

  public Account addAddressItem(Address addressItem) {
    if (this.address == null) {
      this.address = new ArrayList<Address>();
    }
    this.address.add(addressItem);
    return this;
  }

   /**
   * Get address
   * @return address
  **/
  @ApiModelProperty(value = "")
  public List<Address> getAddress() {
    return address;
  }

  public void setAddress(List<Address> address) {
    this.address = address;
  }

  public Account salesman(List<Salesman> salesman) {
    this.salesman = salesman;
    return this;
  }

  public Account addSalesmanItem(Salesman salesmanItem) {
    if (this.salesman == null) {
      this.salesman = new ArrayList<Salesman>();
    }
    this.salesman.add(salesmanItem);
    return this;
  }

   /**
   * Get salesman
   * @return salesman
  **/
  @ApiModelProperty(value = "")
  public List<Salesman> getSalesman() {
    return salesman;
  }

  public void setSalesman(List<Salesman> salesman) {
    this.salesman = salesman;
  }

  public Account balance(BigDecimal balance) {
    this.balance = balance;
    return this;
  }

   /**
   * Get balance
   * @return balance
  **/
  @ApiModelProperty(value = "")
  public BigDecimal getBalance() {
    return balance;
  }

  public void setBalance(BigDecimal balance) {
    this.balance = balance;
  }

  public Account currency(String currency) {
    this.currency = currency;
    return this;
  }

   /**
   * Get currency
   * @return currency
  **/
  @ApiModelProperty(value = "")
  public String getCurrency() {
    return currency;
  }

  public void setCurrency(String currency) {
    this.currency = currency;
  }

  public Account priceType(PriceType priceType) {
    this.priceType = priceType;
    return this;
  }

   /**
   * Get priceType
   * @return priceType
  **/
  @ApiModelProperty(value = "")
  public PriceType getPriceType() {
    return priceType;
  }

  public void setPriceType(PriceType priceType) {
    this.priceType = priceType;
  }

  public Account products(List<Product> products) {
    this.products = products;
    return this;
  }

  public Account addProductsItem(Product productsItem) {
    if (this.products == null) {
      this.products = new ArrayList<Product>();
    }
    this.products.add(productsItem);
    return this;
  }

   /**
   * Get products
   * @return products
  **/
  @ApiModelProperty(value = "")
  public List<Product> getProducts() {
    return products;
  }

  public void setProducts(List<Product> products) {
    this.products = products;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Account account = (Account) o;
    return Objects.equals(this.id, account.id) &&
        Objects.equals(this.name, account.name) &&
        Objects.equals(this.utlIns, account.utlIns) &&
        Objects.equals(this.dtIns, account.dtIns) &&
        Objects.equals(this.utlAlt, account.utlAlt) &&
        Objects.equals(this.dtAlt, account.dtAlt) &&
        Objects.equals(this.deleted, account.deleted) &&
        Objects.equals(this.extra, account.extra) &&
        Objects.equals(this.externalId, account.externalId) &&
        Objects.equals(this.externalSource, account.externalSource) &&
        Objects.equals(this.type, account.type) &&
        Objects.equals(this.vatNumber, account.vatNumber) &&
        Objects.equals(this.email, account.email) &&
        Objects.equals(this.phone, account.phone) &&
        Objects.equals(this.paymentTerm, account.paymentTerm) &&
        Objects.equals(this.paymentMethod, account.paymentMethod) &&
        Objects.equals(this.taxZone, account.taxZone) &&
        Objects.equals(this.taxRule, account.taxRule) &&
        Objects.equals(this.address, account.address) &&
        Objects.equals(this.salesman, account.salesman) &&
        Objects.equals(this.balance, account.balance) &&
        Objects.equals(this.currency, account.currency) &&
        Objects.equals(this.priceType, account.priceType) &&
        Objects.equals(this.products, account.products);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, name, utlIns, dtIns, utlAlt, dtAlt, deleted, extra, externalId, externalSource, type, vatNumber, email, phone, paymentTerm, paymentMethod, taxZone, taxRule, address, salesman, balance, currency, priceType, products);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Account {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    utlIns: ").append(toIndentedString(utlIns)).append("\n");
    sb.append("    dtIns: ").append(toIndentedString(dtIns)).append("\n");
    sb.append("    utlAlt: ").append(toIndentedString(utlAlt)).append("\n");
    sb.append("    dtAlt: ").append(toIndentedString(dtAlt)).append("\n");
    sb.append("    deleted: ").append(toIndentedString(deleted)).append("\n");
    sb.append("    extra: ").append(toIndentedString(extra)).append("\n");
    sb.append("    externalId: ").append(toIndentedString(externalId)).append("\n");
    sb.append("    externalSource: ").append(toIndentedString(externalSource)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    vatNumber: ").append(toIndentedString(vatNumber)).append("\n");
    sb.append("    email: ").append(toIndentedString(email)).append("\n");
    sb.append("    phone: ").append(toIndentedString(phone)).append("\n");
    sb.append("    paymentTerm: ").append(toIndentedString(paymentTerm)).append("\n");
    sb.append("    paymentMethod: ").append(toIndentedString(paymentMethod)).append("\n");
    sb.append("    taxZone: ").append(toIndentedString(taxZone)).append("\n");
    sb.append("    taxRule: ").append(toIndentedString(taxRule)).append("\n");
    sb.append("    address: ").append(toIndentedString(address)).append("\n");
    sb.append("    salesman: ").append(toIndentedString(salesman)).append("\n");
    sb.append("    balance: ").append(toIndentedString(balance)).append("\n");
    sb.append("    currency: ").append(toIndentedString(currency)).append("\n");
    sb.append("    priceType: ").append(toIndentedString(priceType)).append("\n");
    sb.append("    products: ").append(toIndentedString(products)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

